//"SexScripts Tutorial"
// By Banjo (banjosbbs@hotmail.com)
// Version 1.8

// ** AUTHOR NOTES
// This script is HEAVILY based on the default 'test.groovy' script that comes with SexScripts.
// The original was written by Doti, and all credit for the initial idea and versions goes to him.
// I have tried to make this version easier to read and follow, and added a lot more examples.
// Hopefully this will prove a useful reference for those wanting to make their own scripts.
// Cheers, Banjo

// ** COPYRIGHT
// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/4.0/

// ** SCRIPT RESOURCES
// This contains a list of files included with the script when published to the SexScripts website
/*
 * Resources
 * scripts/Banjo/tutorial.groovy
 * images/tutorial/test.gif
 * images/tutorial/test.jpg
 * images/tutorial/test.png
 * sounds/tutorial/test.mid
 * sounds/tutorial/test.mp3
 */

// ** SCRIPT METADATA
// Used on the SS website, this section containts data about your script.
// (SS API version, script title, scrript description, author, status, background colour, language code, tags)
// See the website for common tags, which give users an idea of a script's content (e.g. femaledom, spanking, cbt).
//
// Multiple authors and tags can be separated by colons.
// Language is "en" for english, or whatever language your script's text is in ("fr" for french, etc.).
// Status is "complete" if a script is finished.
// Background colour is a hex code; consult a hex colour chart for values (e.g. 0xFFFFF is white, 0xEEFFF is default pink, etc.).
// See the SexScripts website forum for common tags and other information on metadata.
//
//setInfos(api, "script name", "script description.",
//		"author", "status", hexcolour, "language", ["tag", "tag"]);
//
setInfos(4, "SexScripts Tutorial",
	"Tutorial and example script, demonstrating and explaining various script functions.",
	"Banjo, Doti",
	"v1.8", 0xFFFFFF, "en",
	["test", "utility"]);


// ** BASIC USER INTERFACE COMMANDS
/*
def getRandomItem = { itemKeys ->
	for ( key in itemKeys ) {
		if ( !loadBoolean(key) ) itemKeys -= key
	}
	if ( itemKeys.isEmpty() ) return null
	return itemKeys[ getRandom(itemKeys.size()) ]
}
*/
setImage(null);
show("Welcome to the SexScripts Tutorial!\n\nClick the button below to continue...");

// Displays a clickable button. Will pause until the button is clicked.
showButton("Continue");

show("Buttons are the easiest way to control a script, and can have any text you want on them...");

// You can change the text on a button to anything you like.
showButton("Like this! (continue)");

// Show text in the main window
show("Most information being shown to the user is displayed here, in the main window.");

showButton("Continue");

// When showing text, you can use \n for carriage returns.
show("Text can be displayed here on multiple lines...\nlike this!");

showButton("Continue");

// Use multiple carriage returns for double spacing and adding blank lines.
show("Or\n\nlike\n\n\n\nthis!");

showButton("Continue");

// Use &nbsp; for non-breaking spaces in text.
show("Non-breaking spaces can be inserted in text, if desired, like &nbsp; &nbsp; &nbsp; this!");

showButton("Continue");

// "Cut" a character string for easier editing and reading.
show("All this text appears on the same line, "+
	"however in the script, it is cut for easier reading and editing.")

showButton("Continue");

// Font formatting tags are supported when displaying text.
// <b> </b>  is bold
// <i> </i>  is itallic
// <u> </u>  is underline
// <em> </em>  is emphasis
// <strong> </strong>  is strong
show("HTML style tags are supported for text, such as: <b>bold</b>, <i>itallic</i>, "+
	"<u>underline</u>, <em>emphasis</em> and <strong>strong</strong>.");

// Font formatting is supported for button text, too!
showButton("It works for <i>buttons</i> too!");

show("You can clear the text area (useful for letting an image or sound do the 'talking'), like this...");
showButton("Continue");

// Clear all displayed text using 'null'.
show(null);

showButton("Continue");

show("Text can also be displayed in popup form, like this...");
showButton("Display popup");

//Display text in a popup rather than in the main window. Format tags are not supported.
showPopup("This is a text popup. Click 'OK' to continue.");

show("Buttons are not the only way to control a script...");
showButton("Continue");

show("You can use a 'wait' command.\n\nWaiting for 3 seconds...");
// Wait a number of seconds (here : 3 seconds) without doing anything. This is a pause.
wait(3);

show("3 seconds is up!\n\nWhen a 'wait' ends, the script will move on. This can be used to 'pause'.");
showButton("Continue");
show("You can also 'wait' with a visual gauge.\n\nThis is useful for longer times, and lets the "+
	"user know how long they have left to wait.\n\nWaiting for 6 seconds...\n\n");

// Wait a number of seconds (here : 2 seconds) without doing anything. This is a pause.
waitWithGauge(6);

showButton("Continue");

// ** VALUE COMMANDS

show("Values are variable numbers or text strings, and can be set during a script\n\nFor example, "+
	"the name you were asked to enter when you first ran SexScripts was a value.\n\nValues can "+
	"be shown in text so that the user knows what they are set at.\n\nLet's set some values now...");

// Create and set a new integer value.
def some_number = 5;

// Create and set a new string value.
def colour = "red";

showButton("Continue");

show("Value 'some_number' equals "+some_number+".\n\nValue 'colour' equals "+colour+".");
showButton("Continue");
show("You can change a numerical value mathematically.\n\nLet's add 1 to the value 'some_number'...");
showButton("Continue");

// Mathematiaclly change an integer value. This value must already be defined.
// You can use +, -, / (divide) or * (multiple).
some_number = some_number+1

show("Value 'some_number' now equals "+some_number+".");
showButton("Continue");

show("Values can also be randomly generated, such as simulating a dice roll.\n\nHere, we roll an "+
	"imaginary six-sided die, to get a number between 1 and 6...");
showButton("Roll die");

// Set a value to a random value. In this case, a number between 1 and 6.
// some_number = 50+getRandom(100); would give a range from 50 to 100, for example.
// To CHANGE (not set) a value randomly, use something like: some_number = some_number*getRandom(2);
def dice_roll = 1+getRandom(6);

show("You rolled a "+dice_roll+".");
showButton("Continue");
show("This can be used in interesting ways. For example, want to tell the user to do something a random "+
	"number of times? For example, let's have them hop on one foot between 5 and 20 times...");
showButton("Continue");

// Generate a random number within some text, but don't save it as a value.
// Here, the number is set to a random number between 5 and 20.
show("Hop on one foot "+(getRandom(20)+5)+" times.");

showButton("Continue");
show("This is quick and easy, but only useful when you only need to use the random number once. To 'store' "+
	"the random number for multiple and/or later use, you must set a random value (as we did with the "+
	"virtual dice roll earlier) and use that in our text instead.");
showButton("Continue");

// Generate a random number, set it as a value, and display it in some text.
// Here, the value us 'touchtoes', which is set to a random number between 1 and 10.
def touchtoes = getRandom(10)+1;
show("Touch your toes "+touchtoes+" times.");

showButton("Continue");
show("You can display any value stored in 'data.properties' (the file where settings for SexScripts are "+
	"'saved'), such as the name you entered during setup...");
showButton("Continue");

// Display a value from data.properties in a text string. This must be already defined.
// If the value does not exist, an error will be displayed.
show("Your name is "+(loadString("intro.name"))+".");

showButton("Continue");
show("You can also convert values stored in 'data.properties' to temporary ones specific to the current "+
	"script. They can then be displayed as a normal value.\n\nHere, we set the value 'name' to match "+
	"the name you entered and saved during setup...");

// Create a new value for use in the script, using value stored in data.properties.
def name = (loadString("intro.name"));

showButton("Continue");

// Display a defined value in a text string. If the value does not exist, an error will be displayed.
show("Your name is still "+name+".");

showButton("Continue");
show("Why do that? Because then the value can be changed in this script without altering it in others."+
	"\n\nIt is also less complicated to use in your script.\n\n"+
	"Okay, let's change your name to 'slave' for a moment...");
showButton("Continue");

// Change a string value to something else.
name = "slave";

show("Your name is now "+name+"... but only during this script!\n\nIt will be back to normal in all "+
	"other scripts (unless they use the same value we just created).");
showButton("Continue");
show("A value can also be set to equal another value.\n\nLet's set your name to the value 'colour'...");
showButton("Continue");

// Change a string value to the value of another value.
name = colour;

show("Your name is now "+name+".");
showButton("Continue");
show("Values can be used to create 'if... else' type multiple paths in a script.\n\nFor example, "+
	"remember when we rolled that six-sided die earlier? We rolled a "+dice_roll+", right?\n\n"+
	"We can show different things depending on if this was a high or low number...");
showButton("Continue");

// If an integer value is higher than 3, show one message. Otherwise, show another.
if(dice_roll>3){
	show("Your roll was between 4 and 6.");
}else{
	show("Your roll was between 1 and 3.");
}

showButton("Continue");

// ** USER INPUT COMMANDS

show("We've already seen buttons and wait commands.\n\nNow let's look at other ways to let users "+
	"control the script...");
showButton("Continue");

// Ask a question, with 'yes' or 'no' answer buttons. Yes=true, No=false.
if(getBoolean("You can ask users a simple yes or no question, with buttons.\n\nYes or no?")) {
	show("You chose yes");
}else{
	show("You chose no");
}

showButton("Continue");

// Ask a question, with custom-defined answer buttons.
if(getBoolean("You can change the buttons/answers to something specific, too.\n\nGood or bad?",
	"Good", "Bad")) {
	show("You chose good");
}else{
	show("You chose bad");
}

showButton("Continue");

// Define a value and use getSelectedValue to set it, for multiple choices beyond two options.
def pickcolour = getSelectedValue("Want more than two choices? That's possible too!", ["Red", "Blue", "Yellow"])
if(pickcolour==0) {
	show("You chose red.");
	colour = "red";
}
else
if(pickcolour==1) {
	show("You chose blue.");
	colour = "blue";
}
else
if(pickcolour==2) {
	show("You chose yellow.");
	colour = "yellow";
}

showButton("Continue");

// Get the value selected by the user, optionally from an existing array.
// An array like "berryArray" can be created and used with getSelectedValue as show below.
// You could also do the 3rd and 4th lines below a regular getSelectedValue if you don't need a premade array.
def berryArray = ["strawberry", "blackberry", "blueberry"]
def berryChoice = getSelectedValue("When asking the user to select from multiple choices, we can also use a previously"+
	"generated list of choices (called an 'array') and/or can repeat back the exact choice that was made. The "+
	"results might look the same as the previous example, but look at the code and you'll see how this differs."+
	"\n\nPick a berry:", berryArray)
def berryChosen = berryArray[berryChoice]
show("You picked "+berryChosen+".")

showButton("Continue");

// More with arrays
def seasonArray = ["summer", "autumn", "winter", "chilly"]
def seasonChoice = getSelectedValue("One of the many uses for arrays is to create lists of 'answers' that the user can select "+
	"from. These arrays can even be added to 'on the fly'. For example..."+
	"\n\nChoose your favourite season:", seasonArray)
def seasonChosen = seasonArray[seasonChoice]
show("You picked "+seasonChosen+".... but oops, we forgot spring! And 'chilly' isn't a season!\n\nBetter go back and fix the "+
	"list, then ask again.")
showButton("Continue");

// Add items to an existing array
seasonArray = seasonArray + ["spring"]

// Remove items from an existing array
seasonArray = seasonArray - ["chilly"]

seasonChoice = getSelectedValue("Fixed! Now, let's try that again..."+
	"\n\nChoose your favourite season:", seasonArray)
seasonChosen = seasonArray[seasonChoice]
show("You picked "+seasonChosen+".")

showButton("Continue");
show("Don't worry too much if the stuff about arrays seems a bit complicated; it will make a lot more sense once you look at "+
	"the code, and it's not something you will need to use unless making a complicated script... but it is useful to know!")
showButton("Continue");

// Create a multiple choice dropdown selector. Requires at least 6 choices, or it will be displayed as buttons!
// Remember that the first option is counted as 0, not 1.
def pickoption = getSelectedValue("For user input, you can have a dropdown box instead of buttons, but you MUST have more than "+
	"5 choices for this to work.", ["Option 1", "Option 2", "Option 3", "Option 4", "Option 5", "Option 6"]);
if(pickoption==0) {
	show("You chose option 1.");
}
else
if(pickoption==1) {
	show("You chose option 2.");
}
else
if(pickoption==2) {
	show("You chose option 3.");
}
if(pickoption==3) {
	show("You chose option 4.");
}
if(pickoption==4) {
	show("You chose option 5.");
}
if(pickoption==5) {
	show("You chose option 6.");
}

showButton("Continue");

// Create a multiple choice dropdown selector with less than 6 choices, by way of a loop 'hack'.
// Remember that the first option is counted as 0, not 1.
// The 'fake' options work because we have a 'while' loop running that is only broken when a valid choice is selected!
def dropdown = true;
while (dropdown) {
def pickoption2 = getSelectedValue("What's that? You want a dropdown with less than 6 choices? Well, we can always "+
	"fill the rest with choices that do nothing! Sneaky!", ["Option 1", "Option 2", "Option 3", "?", "?", "?"]);
if(pickoption2==0) {
	show("You chose option 1.");
}
else
if(pickoption2==1) {
	show("You chose option 2.");
}
else
if(pickoption2==2) {
	show("You chose option 3.");
}
if (pickoption2<3) {
	dropdown = false;
}
}

showButton("Continue");

// Ask for user text input; first is the query, then is the default value in the input box.
// Here 'type_text' is used as a value, but any other label could be used in its place.
def type_text = getString("Instead of buttons or dropdowns, you can ask a user for direct input:", "Type something");

// The lines below are never used here (variable "type_text" will not be null because we have a default value)
if(type_text == null) {
	// Ask for an integer number
	def i = getInteger("?",0);
	// Ask for a floating number 
	def f = getFloat("?",0.0);
}

show("You can then display that input in text, as with any other value...\n\nYou typed: "+type_text+"");
showButton("Continue");

show("You can also use this to require a specific input. For example, to demand a correct answer, password, etc.");
showButton("Continue");

// Ask for user number input; this time giving no default response.
def fruit = getString("What colour is an orange?", "");

// Check a value to see if it is *exactly* as required.
def fruitquestion = false;
if(fruit == "orange") {
	show("Correct!");
	fruitquestion = true;
}
else if(fruit == "Orange") {
	show("Correct!");
	fruitquestion = true;
}
else if(fruit == "ORANGE") {
	show("Correct!");
	fruitquestion = true;
}
else {
	show("Wrong!");
}

showButton("Continue");
show("This can of course be done with numbers (integers) too, allowing for more mathematical answers, such as "+
	"checking if your answer is greater or less than a certain number (or even an existing value).");
showButton("Continue");

// Ask for user number input; first is the query, then is the default value in the input box.
def type_number = getInteger("Type a number greater than 5",0);

// Check a value to see if it is *exactly* as required, or else return a different response.
// Operators you can use: '==' (equals exactly), '!=' (doesn't equal), '>' (greater than), '<' (less than).
if(type_number > 5) {
	show("Yes, that number is greater than 5.");
}
else {
	show("No, that number isn't greater than 5.");
}

showButton("Continue");
show("You can refer to any value that has been set earlier, using it for 'branching'.\n\nFor example...\n\n");
showButton("Continue");

// Check an existing value and give a response based on what is found.
if(colour == "red") {
	show("The value 'colour' is set to red.");
	wait(3);
}
if(colour == "blue") {
	show("The value 'colour' is set to blue.");
	wait(3);
}
else {
	show("The value 'colour' is not set to either red or blue.");
	wait(3);
}
if(fruitquestion != true) {
	show("But you didn't know the colour of an orange!");
}

showButton("Continue");
show("You can also use a value as a question. This could be handy for confirming something.\n\n"+
	"The following is based on the colour you chose earlier...");
showButton("Continue");

// Ask a yes or no question based on a defined (existing) value.
if(getBoolean(colour)==true) {
	show("You said yes (true).");
}
else {
	show("You said no (false).");
}

showButton("Continue");
show("When a user gives input of any kind, you can time how long it took them to respond.");

// Get the time elapsed between one user interaction and another, in (rounded) seconds.
def timestamp = getTime();
showButton("Continue");
def timepassed = getTime() - timestamp;

show("You clicked the previous button in "+timepassed+" second(s).");

// Show a button and wait for click before continuing.
// Get the elapsed time (waiting for click), in seconds (floating precision number).
def timetoclick = showButton("Continue");
show("This time you clicked in "+timetoclick+" second(s)");

showButton("Continue");
show("Buttons can be set to 'click themself' if not clicked in a certain timeframe.");
showButton("Continue");
show("The button below will click itself in 10 seconds, unless you click it.");

// Timed button : second argument is optional, but sets a max time waited before auto-click.
// Can be used similarly to CyberMistress' 'ReportLate' function.
showButton("Will click itself in 10 seconds", 10);

show("You can also set a script so that if a button isn't (or is) clicked in time, something "+
	"different happens.");
showButton("Continue");
show("The button below will click itself in 5 seconds, unless you click it.");

// Timed button : clicks itself in 5 seconds : if you are too slow, it performs an action.
// The 'else' condition below is, of course, optional.
// To make this perform an action only if you are NOT too slow, use '!=' in place of '=='.
def timeforbutton = showButton("Click me quick!", 5);
if(timeforbutton==5) {
	show("You were too slow.");
}
else {
	show("You were fast enough.");
}

showButton("Continue");
show("Want a neat trick? How about asking the user to 'stop' when a random number or word is "+
	"shown?");
showButton("Continue");

// Displays a random number between 1 and 6, changing every 2 seconds, until the user clicks and 'picks one'.
def ended = false
def shownumber = 0;
while(!ended){
  shownumber = getRandom(6);
  show("The current number is "+shownumber+".\n\nWhen you see a number you like, click the button.")
  if(showButton("I like this number", 2) <2)
      ended = true;
}

show("You picked "+shownumber+".");
showButton("Continue");

show("Here's another trick... you can have a random option selected secretly, following a button or "+
	"wait (for example) to add some unpredictablity to your script.");
showButton("Continue");

// Set a value randomly and show the result, without the user having any influence.
def choosemessage = 1+getRandom(3);
if(choosemessage==1) {
	show("Message 1 was randomly selected.");
}
if(choosemessage==2) {
	show("Message 2 was randomly selected.");
}
if(choosemessage==3) {
	show("Message 3 was randomly selected.");
}

showButton("Continue");
show("Simple enough... but if you're feeling mean you can 'trick' the user into thinking that they "+
	"have a choice in the next option, when really they don't!");
showButton("Continue");

// Set a value randomly and show the result, while ignoring the user's choice completely.
def choosemessage2 = 1+getRandom(3);
if(getBoolean("Would you like Option A or B?","Option A","Option B")) {}
if(choosemessage2==1) {
	show("Who cares? Option A was randomly selected.");
}
if(choosemessage2==2) {
	show("Who cares? Option B was randomly selected.");
}
if(choosemessage2==3) {
	show("Who cares? Option C was randomly selected.");
}

showButton("Continue");
show("Another form of user input is checkboxes...");
showButton("Continue");

// Show a dialog box with checkboxes inside, to be checked or not.
// Parameters : title, values, defaultValues.
// Return a list of boolean (checked or not), or null if [Cancel] clicked.
//Again, remember that the first box will be 0, not 1.
def checkboxes = getBooleans("Which do you like?",["Chocolate", "Beer"], [false, false]);
if(checkboxes != null) {
	if (checkboxes[0]==true) {
		show("You like chocolate.");
		if(checkboxes[1]==true) {
			show("You like both!");
		}
	}
	else if (checkboxes[1]==true) {
		show("You like beer.");
		if(checkboxes[0]==true) {
			show("You like both!");
		}
	}
else {
	show("You don't like either.");
	}
}

showButton("Continue");

// ** SAVING AND LOADING DATA COMMANDS (file data.properties)

show("Interacting with a user's list of owned toys or clothes can make a script more unique and personal.\n\n"+
	"This can also be used to check that users own an item specifically required by your script.");
showButton("Continue");
show("You can check to see if a user owns a specific toy, such as a paddle...");
showButton("Continue");

// Load a boolean and check if it is true (example: to check if the user owns a specific toy or not).
if(loadBoolean("toys.paddle")) {
	show("You own a paddle.");
}
else {
	show("You don't own a paddle.");
}

showButton("Continue");
show("You can also check for two or more toys at once...");
showButton("Continue");

// Load multiple booleans and check if all are true (example: to check if the user owns two or more toys).
if(loadBoolean("toys.handcuffs") && loadBoolean("toys.ballgag")) {
	show("You own handcuffs and a ballgag.");
}
else {
	show("You don't own handcuffs and a ballgag.");
}

show("... or whether the user owns one out of of several toys...");
showButton("Continue");

// Load multiple booleans and check if any one is true (example: to check if the user owns at least one of the toys on a list).
if(loadBoolean("toys.dildo") || loadBoolean("toys.vibrating_dildo") || loadBoolean("toys.strapon_dildo") || loadBoolean("toys.vibrator")) {
	show("You own at least one dildo or vibrator.");
}
else {
	show("You don't own any dildos or vibrators.");
}

showButton("Continue");
show("Or you can check for multiple similar toys, to see if they own an item that substitute another."+
	"\n\nFor example, a dildo or a vibrating dildo could be used in place of each other, so we "+
	"should check if either is owned by the user...");
showButton("Continue");

// Load multiple booleans and find the first one that's 'true' (userful for multiple toys, clothes...).
def toy = loadFirstTrue("toys.vibrating_dildo", "toys.dildo");
if(toy==null) {
	show("You don't own a dildo.");
}
else {
	show("You own a dildo.");
}

showButton("Continue");
show("Normally, values will only be saved while the current script is running; they will not be saved across "+
	"scripts. However, you can save them to 'data.properties' to be used again another time.\n\n"+
	"They can later be recalled in the same or another script the way we recalled your name from setup."+
	"\n\nTo best understand how this is done, examine this script ('tutorial.groovy') to see how the "+
	"following number was determined across all the times you've run this tutorial.");
showButton("Continue");

// Load a number from disk, or null (if not found)
def n = loadInteger("test.counter"); 

// Floating decimal numbers may be read also
if(n == null)
	n = loadFloat("test.alternative_inexistant_counter");

// Simple strings may be read also
if(n == null)
	n = loadString("test.alternative_inexistant_counter2");

// Booleans (true / false)
if(n == null)
	n = loadBoolean("test.alternative_inexistant_counter3");
if(n == null)
	n = 0;

// getRandom(max) returns a number between 0 and max (excluded), here : 0, 1 or 2 
n = n + 1 + getRandom(3);
show("You have run this tutorial less than "+n+" times");

//save data ; warning, you may erase another value of the same key (here "test.counter")
//from another script ! A good idea is doing like below, prefixing with script name.
save("test.counter", n);

showButton("Continue");
show("The previous value was calculated using numerical values that are incremented and saved to "+
	"'data.properties' every time this script is run.\n\nAgain, examine this script "+
	"('tutorial.groovy') for more details.");
showButton("Continue");

// ** FILE READ & WRITE COMMANDS

show("You can also write to a plain text file (.txt), either existing or a new one.\n\nThis "+
	"could be used for keeping a log of a user's actions, for example.");

// Write to an external text file (here, a new file called 'test.txt').
// Will overwrite text in an existing file of the same name.
// Stores the file in the main SexScripts folder : use subfolders if you wish.
// Here, we use the value 'writetext' but it could be anything.
def writetext = new File("test.txt")
writetext.write("first line")
writetext.append(System.getProperty("line.separator"))
writetext.append("second line")

showButton("Continue");
show("Information in a text file can also be displayed.\n\nThis could be used "+
	"for anything from displaying a log to 'reading a story' to the user.\n\n"+
	"Note that text will be overwritten if you write to a file that exists.");
showButton("Continue");

// Read and show all lines in an external text file (here 'test.txt').
// Here, we use the values 'readtext', 'line' and 'lines', but these could be anything.
// This shows the whole text file, 1 line at a time, with a 2s wait between lines.
def readtext = new File("test.txt")
def lines = readtext.readLines()
for(def line : lines) {
   show(line)
   wait(2)
}

showButton("Continue");
show("You can also write to a Windows INI file, for storing or changing specific "+
	"configuration settings, for example.");

// Write to an INI (.ini) file (here, two lines are added).
// Stores the file in the main SexScripts folder : use subfolders if you wish.
// Here, we use the value 'writeini' but it could be anything.
def writeini = new org.ini4j.Wini()
writeini.put("section1", "key1", "value1")
writeini.put("section1", "key2", "value2")
writeini.store(new File("test.ini"))

showButton("Continue");
show("INI files can also be read by SexScripts, and this information can be "+
	"used to set a value.");
showButton("Continue");

// Set a value by reading an INI file setting.
// Here, we set a value to equal 'section1', key1' of the INI.
// Here, we use the value 'readini2' but it could be anything.
def readini2 = new org.ini4j.Wini(new File("test.ini"))
def inivalue = (readini2.get("section1", "key1"))

show("The value 'inivalue' is set to "+inivalue+".");
showButton("Continue");
show("Or we can display the information in the INI file to the user...");
showButton("Continue");

// Read from an INI (.ini) file and display results.
// Here, we use the value 'readini' but it could be anything.
def readini = new org.ini4j.Wini(new File("test.ini"))
show(readini.get("section1", "key1") + " "+readini.get("section1", "key2"))

showButton("Continue");
show("You can examine the two files ('test.txt' and 'test.ini') in your SexScripts "+
	"folder to see how these were written to.");
showButton("Continue");

// ** IMAGE COMMANDS

show("Spicing up your scripts with multimedia will really make it memorable."+
	"\n\nImages are the simplest type of multimedia to display, and will "+
	"appear in the main window alongside any shown text...");
showButton("Continue");
show("Displaying a .jpg image...");

// Show an image (file must be in "images/" directory, perhaps in a sub-directory)
// Extensions jpg, jpeg, png, gif (static or animated) are supported. png and gif supports transparency.
setImage("tutorial/test.jpg");

showButton("Continue");
show("Displaying a .gif image...\n\nNote that both transparency and animation are supported.");

setImage("tutorial/test.gif");

showButton("Continue");
show("Displaying a .png image...\n\nTransparency is fully supported here, too.");

setImage("tutorial/test.png");

showButton("Continue");
show("A displayed image will remain onscreen until a new one is displayed.\n\nAlternatively, "+
	"an image can be cleared in a similar way to text...");
showButton("Continue");

// Clear any image currently shown (i.e. show nothing).
setImage(null);

show("Cleared image!");
showButton("Continue");
show("It is possible to display a random image, so long as you set a 'range' (for example, a script "+
	"can randomly display an image from a gallery of 10 images, providing they are named correctly).");
showButton("Continue");

// Pick and display a random image. Here, we select from two (default-female.jpg and default-male.jpg).
// Care must be taken to ensure the images you allow to be picked actually exist.
def randomimage = 1+getRandom(2);
def imagetopick = "female";
if(randomimage == 1) {
	imagetopick = "female";
}
if(randomimage == 2) {
	imagetopick = "male";
}

setImage("default-"+imagetopick+".jpg");

// If you want to select a random image from a specific number of multiple images, use the following method:
// This example would pick a random image from the folder 'Sarah', choosing from 'Sarah1.jpg' to 'Sarah12.jpg'.
// Because these files don't exist, this example has been commented out below.
//setImage("Sarah"+(1+getRandom(12))+".jpg");

showButton("Continue");
show("You can also ask the user for a specific file (such as a photo of themselves) to use in a script.");
showButton("Continue");

// Ask for a file to be selected from the user's hard drive.
def yourPic = getFile("Select an image.");

show("You can then display the image back to the user.");

// Display an image based on a value (i.e. set a value to have the path to an image and this will recall it).
// First checks if the user actually selected an image or not, and displays an error if not.
if(yourPic==null)
	show("You didn't select an image.");
else {
	show("You can then display the image back to the user.");
	setImage(yourPic);
}

showButton("Continue");
show("If you want to copy the selected file to the user's SexScripts images folder, this can be done too...");
showButton("Continue");

// Ask for a file from the user's hard drive and saves it with a new name to the SS 'images' folder.
// The subfolder the image is saved to here is 'tutorial', the new name given is 'yourPic.jpg'.
// The second line here deletes any old 'yourPic.jpg' if it exists, to avoid conflicts when renaming.
def yourPicFile = getFile("Select an image.");
new File("images/tutorial/yourPic.jpg").delete();
new File("images/tutorial/yourPic.jpg") << new File(yourPicFile).getBytes();

// Show image in a subfolder : here, the image is in the folder 'images/tutorial'.
setImage("tutorial/yourPic.jpg");

show("Again, this image can then be displayed back to the user in the normal way.");
showButton("Continue");
setImage(null);

// setImageOverlay("background","overlay",xpos,ypos)
// Credit to Liz for writing this script, which allows you to use "setImageOverlay("background","overlay",xpos,ypos)" as a command
// Substitute "background" for your background image filename, "overlay" for your foreground (overlaid) image filename,
// x for horizontal position of overlay and "y" for vertical position of overlay.
// Caution: this script is NOT useable with the Android port of SexScripts!
def setImageOverlay = { picture, opicture, xpos, ypos ->
  def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
  def width = image.getWidth()
  def height = image.getHeight()
  def oimage = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+opicture)
  def owidth = oimage.getWidth()
  def oheight = oimage.getHeight()
 
  def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
  def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
  def osprite = javax.imageio.ImageIO.read(new File("images/"+opicture))
  java.awt.Graphics2D graphics = frameBuffer.createGraphics()
  graphics.drawImage(sprite,0,0,width,height, null)
  graphics.drawImage(osprite,xpos,ypos,owidth,oheight, null)
 
  java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
  javax.imageio.ImageIO.write(frameBuffer, "png", baos)
  setImage(baos.toByteArray(),0) 
}

show("SexScripts supports a lot more than the built-in functions if you know how to code in Groovy.\n\n"+
	"For example, we can use a custom script to overlays one image on top of another...");
showButton("Continue");
show("Pretty cool, huh?");

setImageOverlay("tutorial/test.jpg","tutorial/test.png",350,250);

// ** AUDIO COMMANDS

show("Sounds are another great way to add fun to a script.")
showButton("Continue");
show("Now playing a .wav sound...");

// Play sound (file must be in "sounds/" directory, or in a sub-directory).
// Supported formats include .wav, .mp3 and .mid.
// playSound() will wait the end of the sound.
playSound("whip.wav");

wait(2);
show("Now playing an MP3 sound...");
playSound("tutorial/test.mp3");
wait(2);

show("Now playing a midi (.mid) sound...");
playSound("tutorial/test.mid");
wait(2);

show("When a single sound is played, the script will continue when it is finished.\n\n"+
	"You can also play a sound multiple times in a row, as a 'loop'.");
showButton("Continue");
show("Now playing a sound 3 times in a row (loop)...");

// Create multi-sound loop (here, '3' equals how many times to play the sound).
// Wait (here, 1 second) is the pause between each time the sound is played.
for(def i=0; i<3;i++) {
	// playBackgroundSound() will not wait the end of the sound.
	playBackgroundSound("whip.wav");
	wait(1);
}

showButton("Continue");
show("You can loop different sounds together in a 'pattern', too...");

// Create a continuous sound loop with multiple different sounds and delays.
for(def i=0;i<3;i++) {
	playSound("tom.wav")
	wait(1);
	playSound("tom.wav")
	wait(1);
	playSound("whip.wav")
	wait(2);
}

showButton("Continue");
show("Another way to loop sounds is to have them play repeatedly until the user clicks a button.");

// Create a continuous sound loop : ends when the button is clicked : 3 = delay between sound playbacks.
def soundloop = true;
while(soundloop == true) {
	playBackgroundSound("tom.wav")
	if(showButton("Stop Sounds", 3) < 3)
		soundloop = false;
}

show("If you ever need to stop all playing sounds, this can be done similarly to how images are cleared.");

//Stop all playing sounds.
playSound(null);

showButton("Continue");

// ** VIDEO COMMANDS

show("SexScripts can open an external file using your system's associated programs.\n\nFor example, a video "+
	"may be played using your system's default video player.\n\nSupported file types depend on your "+
	"system's players and file associations.");
showButton("Continue");
show("Attempting to play an .mp4 video file (default player will open)...");

// useFile() will try to open a file with anything available on the system.
// Supported video files are determined by file types supported by the player used.
useFile("videos/test.mp4");

showButton("Continue");

// ** OTHER MULTIMEDIA COMMANDS (INTERNET, EMAIL, HARDWARE, ETC)

show("SexScripts can open specific web pages, via your web browser.");
showButton("Continue");
show("Opening SexScripts webpage (will use your system's default web browser)...");

// useUrl() will try to open your default browser with the specified URL.
useUrl("http://ss.deviatenow.com");

showButton("Continue");

show("It can open your email client with a specified address to send to.\n\nThis will NOT send "+
	"unless you tell it to, however.");
showButton("Continue");
show("Opening email address (will use your system default email program)...");

//useEmailAddress() will try to open an email adress with the mail program associated. Doesn't send.
useEmailAddress("test@sexscripts.com");

showButton("Continue");

show("It can automatically open the computer's CD trays.\n\nThis could be used to hold a small "+
	"key taped inside, for example, for a chastity device, handcuffs or locked strongbox.");
showButton("Continue");
show("Opening CD trays...");

//openCdTrays() will open all cd trays.
openCdTrays();

showButton("Continue");

// ** TIME AND DATE FUNCTIONS

// Set an integer value to the "UNIX Timestamp" (how many seconds have passed since January 1st, 1970).
//To convert this to 'human readable' (real) time, use the following two lines:
//def realtime = new Date(epochtime*1000L).format( "yyyy-MM-dd HH:mm:ss"));
def epochtime = getTime();

show("A special value command is the UNIX Timestamp (number of seconds since 1st January, 1970)...\n\n"+
	"The UNIX Timestamp (Epoch Time) is currently "+epochtime+".");
showButton("Continue");

//Convert Epoch Time to 'human readable' (real) time.
def realtime = new Date(epochtime*1000L).format("dd-MM-yyy HH:mm:ss");

show("This can be automatically converted to a more easily-readable format...\n\n"+
	"UNIX Timestamp: "+epochtime+".\nCurrent Time/Date: "+realtime+".");
showButton("Continue");

// Set an integer value to the current date and time.
def date_time = new Date().format("dd-MM-yyyy HH:mm:ss");

show("Don't worry, you can find and show the 'normal' time and date too!\n\n"+
	"You can even pick the format, such as whether days or months are shown first.\n\n"+
	"It is currently "+date_time+".");
showButton("Continue");

// ** ADVANCED TIPS

show("Advanced Tip:\n\nYou can have a script automatically delete files, such as unwanted images "+
	"imported by the user or temporary text files created by your script.\n\nBe VERY careful "+
	"with this, though! Normally, you should not need to do this, but it is handy to know how.");
showButton("Continue");

if(getBoolean("Delete test files created by this script?")) {
	// Delete a specific file (if it exists); be careful!
	new File("images/tutorial/yourPic.jpg").delete();
	new File("test.ini").delete();
	new File("test.txt").delete();
	show("Test files deleted.");
}else{
	show("Test files not deleted.");
}
showButton("Continue");

if(getBoolean("Advanced Tip: You can ask a user if they want to quit... and end the script!",
	"Quit", "Don't Quit")) {
// Interrupt script and end it.
// You may use 'return "abc";' instead, in order to launch abc.groovy after the script ends.
	return;
}

// ** SCRIPT METADATA EDITING

show("One last thing... did you notice that the background of SexScripts was white rather than the default "+
	"pink during this tutorial?\n\nThat's because we can change the background colour for a script "+
	"before it loads.\n\nAt the start of any script, there should be a few lines beginning with "+
	"&quot;setInfos&quot;.");
showButton("Continue");

// More information on script metadata (setInfos) can be found at the start of this script in comment form.

show("It should look something like this:\n\n"+
	"setInfos(api version, &quot;script name&quot;, &quot;script description.&quot;,\n"+
	"&quot;script author&quot;, &quot;status&quot;, hexcolour, &quot;language&quot;, "+
	"[&quot;tag1&quot;], [&quot;tag2&quot;]);&quot;"+
	"\n\nMost sections should be obvious as to what you should enter, but detailed information on this section "+
	"can be found on the SexScripts forums and this script's comments. Most of this information is only important "+
	"when uploading your script to the SexScripts website, however, to change background colour, replace "+
	"hexcolour here with any hex colour code, such as 0xFFFFF (hex colour code charts can be found online).");
showButton("Continue");

// ** ENDING

show("This is the end of the tutotrial.\n\nTo see how everything in this script was done, you should run "+
	"it again, but this time open the file 'tutorial.groovy' in whatever text editor you prefer "+
	"(such as Windows Notepad, Notepad++, or EditPad) and follow along in the code./n/n"+
	"Comments will be shown in the file (preceeded by '//') to explain things further.");

showButton("Continue");
show("Have fun creating your own scripts!");
showButton("Exit");
show(null);
setImage(null);
// ** EXIT SEQUENCE FOR BANJO'S IMPROVED SETUP COMPATIBILITY
if(loadBoolean("setting.newsetup")) {
	if(loadBoolean("setting.reload")) {
		return "system/welcome"
	}
	else {
		return "exit"
	}
}
else {
	return null
}
//END OF SCRIPT
